

var baud = 38400;
var connId = [];
var initDone = 0;
var hexFile = 0;
var connected = 0;
var BlockName = 'page';
var BlockStartSign = 70;
var connectTo = 'KISSFC';
var targetSelection = 0;
var pages = [];
var fastMode = 0;
var fastmodewarningdone = 0;

function doOnload(){
	document.getElementById('doit').onclick = function(){
		writeFlash();
	}	
	
	document.getElementById('fastmodeOn').onchange = function(){
		if(this.checked){
			if(fastmodewarningdone == 0){
				fastmodewarningdone = 1;
				document.getElementById('text').innerHTML = "in fast mode ESC's <span style='text-decoration:underline;'>without</span> bootloader will spin up!"
				document.getElementById('warning').style="display:block;"
			}
			fastMode = 1;
			visibleLog('fast mode enabled');
		}else{
			fastMode = 0;
			visibleLog('fast mode disabled');	
		}
	}
	
	document.getElementById('source').addEventListener('change', function(evt){
		var fileLoaded = document.getElementById('source').value.split('\\');
		visibleLog('reading file: '+fileLoaded[fileLoaded.length-1])
		var reader = new FileReader();
		reader.onload = (function(theFile) {
			return function(e) {
				hexFile = e.target.result;
				parseHexFile();
			};
		})(evt.target.files[0]);

		reader.readAsText(evt.target.files[0]);		
	}, false);	
	
	document.getElementById('contype').onchange = function(){
		targetSelection = this.value;
		if(targetSelection == 0){
			connectTo = 'KISSFC';
			visibleLog('connect to a KISSFC');	
		}
		if(targetSelection == 1){
			connectTo = 'USBUART';
			visibleLog('connect to a USB-UART');	
		}
	}
	
	document.getElementById('Bok').onclick = function(){
		document.getElementById('warning').style="display:none;"
	}		
	
}

function openPort(ports){
	document.getElementById('close').innerHTML = '';
	document.getElementById('comsel').innerHTML = '';
	
	var portwahl = document.createElement('select');
	portwahl.onchange = function(){
		openSerial(this.value);
	};
	portwahl.id = 'comselin';
	var portOpt = document.createElement('option');
	portOpt.value = '';
	portOpt.innerHTML = 'Select com Port';
	portwahl.appendChild(portOpt);
	
	for(var i in ports){
		var portOpt = document.createElement('option');
		portOpt.value = ports[i].path;
		portOpt.innerHTML = ports[i].path;
		portwahl.appendChild(portOpt);
	}
	document.getElementById('comsel').appendChild(portwahl);
	
	
	var refresh = document.createElement('input');
	refresh.type = 'button';
	refresh.value = 'Refresh';
	refresh.style.fontSize = '11px';
	refresh.style.width = '80px';
	refresh.onclick = function(){
		chrome.serial.getDevices(function(ports){
			openPort(ports);
		});
	}
	document.getElementById('close').appendChild(refresh);
}

function openSerial(portVal){
	document.getElementById('close').innerHTML = '';
	if(portVal == '') return;
	if(initDone == 0){
		chrome.serial.onReceive.addListener(serRead);
	}
	document.getElementById('comsel').removeChild(document.getElementById('comselin'));
        chrome.serial.connect(portVal, {bitrate: baud},serOpen);
	
	var closeComm = document.createElement('input');
	closeComm.type = 'button';
	closeComm.value = 'Close COM';
	closeComm.style.fontSize = '11px';
	closeComm.style.width = '80px';
	visibleLog('connected to '+portVal);
	closeComm.onclick = function(){
		chrome.serial.send(connId.connectionId,str2ab(''), closen);
	}
	document.getElementById('close').appendChild(closeComm);
	saledPort  = portVal;
	var opening = document.createElement('h2');
	opening.innerHTML ="selecting port: "+portVal;
	opening.id="opening";
	connected = 1;
	console.log(connectTo);
}

function serOpen(cInfo){
	connId = cInfo;
	if(document.getElementById('opening')){
		document.body.removeChild(document.getElementById('opening'));
	}
	document.getElementById('comsel').innerHTML = saledPort;
}

function serRead(info){
	if(info){
		if(info.data.byteLength > 0) {	
			var data = new Uint8Array(info.data);
			for(var i = 0; i< data.length; i++){
				if( data[i] == 'A'.charCodeAt(0) && connectTo == 'KISSFC'){
					connectTo = 'KISSFC ok';
					visibleLog('get ESC\'s to BL mode');
					setTimeout(function(){
						if(writing == 1){
							actPage = pages.length;
							useTimeout = 1800;
							WritePage();
						}else visibleLog('Stopped');
					},2500);
				}
			}
		}
	}
}

function Write(data){
	chrome.serial.send(connId.connectionId, str2ab(data), onWrite);
}

function onWrite(){
	
}

function closen(){
	chrome.serial.disconnect(connId.connectionId, function(){chrome.serial.getDevices(function(ports){
		openPort(ports);
	});});
	visibleLog('com closed');
	connected = 0;
}

function onFlush(){
	
}


function getA2sign(numb){
	return String.fromCharCode(numb);
}


onload = function(){
	doOnload();
	chrome.serial.getDevices(function(ports){
		openPort(ports);
	});
}

onclose = function(){
	chrome.serial.disconnect(connId.connectionId, function(){});
	
};



function update_crc8(crc, crc_seed){
	crc_u = crc;
	crc_u ^= crc_seed;
	for ( i=0; i<8; i++){
		crc_u = ( crc_u & 0x80 ) ? 0x7 ^ ( crc_u << 1 ) : ( crc_u << 1 );
		if(crc_u > 256) crc_u -= 256;
	}
	return (crc_u);
}

function visibleLog(line){
	document.getElementById('ConSole'). innerHTML+= line+'<br \>';
	document.getElementById('ConSole').scrollTop = document.getElementById('ConSole').scrollHeight;
}


function parseHexFile(){
	pages = [];
	var ByteArr = [];
	var hexFileArr = hexFile.replace(/(?:\r\n|\r|\n)/g, '').split(':');
	for(var i = 0; i < hexFileArr.length;i++){
		var lineArr = hexFileArr[i].split("");
		if(i == 3){
			if(parseInt(lineArr[3]) == 4){
				BlockName = 'page';
				BlockStartSign = 70;
			}else if(parseInt(lineArr[3]) == 8){
				BlockName = 'block';
				BlockStartSign = 69;			
			}else{
				visibleLog('this hexfile cant be loaded as it is not bootloder conform');
				pages = [];
				return;
			}
		}
		if(parseInt('0x'+lineArr[6]+lineArr[7]) == 0){
			for(var y=8;y<lineArr.length-2;y+=2){
				ByteArr.push(parseInt('0x'+lineArr[y]+lineArr[y+1]));
			}
		}
	}
	var pagecounter = 0;
	var pageBytecounter = 0;
	var crc = 0;
	
	// resize to full pages
	var fittingpages = Math.ceil(ByteArr.length/64);
	var leftBytes = (fittingpages*64)-(ByteArr.length);
	visibleLog('loaded: '+ByteArr.length+' bytes');
	for(var i = 0;i< leftBytes;i++){
		ByteArr.push(255);
	}
	visibleLog(BlockName+' conform: '+ByteArr.length+'bytes, '+ByteArr.length/64+' '+BlockName+'s');
	
	for(var i = 0; i< ByteArr.length; i++){
		if(pageBytecounter == 0){
			pages[pagecounter] = [];
			crc = update_crc8(BlockStartSign, 0);
			pages[pagecounter].push(BlockStartSign);
			pages[pagecounter].push(BlockStartSign);
			pages[pagecounter].push(BlockStartSign);
			
			crc = update_crc8((pagecounter&0xFF), crc);
			pages[pagecounter].push((pagecounter&0xFF));
			pages[pagecounter].push((pagecounter&0xFF));
			pages[pagecounter].push((pagecounter&0xFF));
			
			crc = update_crc8((pagecounter>>8), crc);
			pages[pagecounter].push((pagecounter>>8));
			pages[pagecounter].push((pagecounter>>8));
			pages[pagecounter].push((pagecounter>>8));
			
			if(pagecounter < (ByteArr.length/64)-1){
				crc = update_crc8(0, crc);
				pages[pagecounter].push(0);
				pages[pagecounter].push(0);
				pages[pagecounter].push(0);
			}else{
				crc = update_crc8(255, crc);
				pages[pagecounter].push(255);
				pages[pagecounter].push(255);
				pages[pagecounter].push(255);				
			}
		}
		crc = update_crc8(ByteArr[i], crc);
		pages[pagecounter].push(ByteArr[i]);
		pages[pagecounter].push(ByteArr[i]);
		pages[pagecounter].push(ByteArr[i]);		
		pageBytecounter++;
		if(pageBytecounter == 64){
			pageBytecounter = 0;
			pages[pagecounter].push(crc);
			pages[pagecounter].push(crc);
			pages[pagecounter].push(crc);			
			pagecounter++;
		}
	}
}

var actPage = 0;
var useTimeout = 1800;

var writing = 0;
function writeFlash(){
	if(writing == 0){
		if(!connected){
			visibleLog('please connect to a com port.');
			return;
		}
		if(pages.length == 0){
			visibleLog('please select a valid hex file.');
			return;
		}
		if(connectTo == 'KISSFC'){
			visibleLog('Setting KISS FC to ESC write mode');
			var InfoString = ['A'.charCodeAt(0)];
			Write(InfoString);
			visibleLog('waiting for FC');
			setTimeout(function(){
				if(connectTo == 'KISSFC') visibleLog('got no answer. check your com port selection and see if you have the lastest KISSFC version.');
			},2000);
			writing = 1;
			document.getElementById('doit').value ="Stop";
			return;
		}
		writing = 1;
		document.getElementById('doit').value ="Stop";
		actPage = pages.length;
		useTimeout = 1800;
		WritePage();
	}else{
		writing = 0;
		document.getElementById('doit').value ="Write flash";
	}
}

function WritePage(){
	RXhead = 0;
	var sendStr = '';
	
	actPage--;
	if(actPage >= 0){
		Write(pages[actPage]);
	}else{
		var startApp = [83,83,83];
		Write(startApp);
		visibleLog('done.');
		document.getElementById('doit').value ="Write flash";
		writing = 0;
		return;
	}
	visibleLog('sending '+BlockName+' '+(actPage+1)+' ('+((1000-Math.round(actPage/((pages.length)/1000)))/10)+'%)');
	
	if(writing == 1){
		setTimeout(function(){WritePage();},useTimeout);
		if(fastMode) useTimeout = 65;
		else useTimeout = 500;
	}else visibleLog('Stopped');
}







//part of chrome serial lib
/**
Copyright 2012 Google Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Author: Renato Mangini (mangini@chromium.org)
Author: Luis Leao (luisleao@gmail.com)
**/

var str2ab = function (arr) {
        var buf = new ArrayBuffer(arr.length);
        var bufView = new Uint8Array(buf);
        for (var i = 0; i < arr.length; i++) {
            bufView[i] = arr[i];
        }
        return buf;
};










